Class grabinPawn extends xPawn;

const FilterFrames = 5;
var int NextHistorySlot;
var bool bHistoryWarmup;
var vector CameraHistory[FilterFrames]; //vars for special behindview
var gestureInventory GestureInv; //the class that handles all gesturing

replication
{
	reliable if (ROLE == ROLE_Authority)
		giveGesture, setGestureState;
}

simulated function bool SpecialCalcView(out actor ViewActor, out vector CameraLocation, out rotator CameraRotation )
{
	local vector CamLookAt, HitLocation, HitNormal;
	local PlayerController pc;
	local int i, averageOver;
	
	pc = PlayerController(Controller);
	
	if(pc == none || !pc.bBehindView)
		return false;	//do normal calcview if not behindview
		
	ViewActor = self;
	CamLookAt = Location + (vect(-100, 0, 100) >> Rotation);

	//////////////////////////////////////////////////////
	// Smooth lookat position over a few frames.
	CameraHistory[NextHistorySlot] = CamLookAt;
	NextHistorySlot++;

	if(bHistoryWarmup)
		averageOver = NextHistorySlot;
	else
		averageOver = FilterFrames;

	CamLookAt = vect(0, 0, 0);
	for(i=0; i<averageOver; i++)
		CamLookAt += CameraHistory[i];

	CamLookAt /= float(averageOver);

	if(NextHistorySlot == FilterFrames)
	{
		NextHistorySlot = 0;
		bHistoryWarmup=false;
	}
	//////////////////////////////////////////////////////

	CameraLocation = CamLookAt + (vect(-200, 0, 0) >> CameraRotation);

	if( Trace( HitLocation, HitNormal, CameraLocation, CamLookAt, false, vect(10, 10, 10) ) != None )
	{
		CameraLocation = HitLocation;
	}
	
	/*if(Crosshair != None)
	{		
		//THE FOLLOWING CODE IS VERY IMPORTANT FOR UNDERSTANDING AIMING AND I SHOULD USE IT FOR GUNS
		
		StartTrace = Location;
		StartTrace.Z += BaseEyeHeight;
		EndTrace = StartTrace + vector(CameraRotation)*16384;
		
		if(Trace(HitLocation, HitNormal, EndTrace, StartTrace, true) == None)
			HitLocation = EndTrace;

		Distance = VSize(HitLocation - StartTrace);

        	Crosshair.SetLocation(HitLocation - vector(CameraRotation)*FMax(Distance/16, 16));
	}*/
	return true;
}

simulated event PlayDying(class<DamageType> DamageType, vector HitLoc)
{	//playdying instead of destroy to make xhair go away immediately when killed
	Super.PlayDying(DamageType, HitLoc);
}

simulated event destroyed()	//double check xhair gone, if killed by other means
{
	Super.Destroyed();
}

simulated function GiveGesture(string aClassName )
{
	local class<gestureInventory> InvClass;
	
	InvClass = class<gestureInventory>(DynamicLoadObject(aClassName, class'Class'));
	//log("UUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUURGH");
	if( FindInventoryType(InvClass) != None )
		return;
	GestureInv = Spawn(InvClass);
	if( GestureInv != None )
	{
		//log("FEEDED " $ GestureInv);
		GestureInv.GiveTo(self);
		GestureInv.P = self;  //assignment so that inv class can reference back easily
		GestureInv.SetupGesture();
	}
}

simulated function setGestureState(name stateID)
{  //PRI cant directly access gestureINV, hence this replicated interpreter function
	gestureInv.gotoState(stateID);
}

defaultproperties
{
     bHistoryWarmup=True
     bFullVolume=True
     SoundOcclusion=OCCLUSION_BSP
     SoundRadius=128.000000
     bSpecialCalcView=True
}
