//=============================================================================
// sword
// Used by the s_Melee when we can not use the more ehnaced vrs
// of Melee combat.
// $Id: sword.uc,v 1.8 2003/12/04 04:04:23 jb Exp $
//=============================================================================
class sword extends s_Melee config(user);

#EXEC OBJ LOAD FILE=InterfaceContent.utx

simulated function PostNetBeginPlay()
{
    Super.PostNetBeginPlay();

    if ( (Role < ROLE_Authority) && (Instigator != None) && (Instigator.Controller != None) && (Instigator.Weapon != self) && (Instigator.PendingWeapon != self) )
        Instigator.Controller.ClientSwitchToBestWeapon();
}

simulated function DrawWeaponInfo(Canvas Canvas)
{
    local int i,Count;
    local float ScaleFactor;

    Count = Min(8,Ammo[1].AmmoAmount);
    ScaleFactor = 99 * Canvas.ClipX/1600;
    Canvas.Style = ERenderStyle.STY_Alpha;
    Canvas.DrawColor = class'HUD'.Default.WhiteColor;

    for( i=0; i<Count; i++ )
    {
        Canvas.SetPos(Canvas.ClipX - (0.5*i+1) * ScaleFactor, 0.75 * Canvas.ClipY);
        Canvas.DrawTile( Material'InterfaceContent.Hud.SkinA', ScaleFactor, ScaleFactor, 0, 520, 99, 99);
    }
}

function byte BestMode()
{
    if ( (FRand() < 0.1) && (Ammo[1].AmmoAmount >= FireMode[1].AmmoPerFire) )
        return 1;
    if ( Ammo[0].AmmoAmount >= FireMode[0].AmmoPerFire )
        return 0;
    return 1;
}

simulated function float ChargeBar()
{
    return FMin(1,FireMode[1].HoldTime/AssaultGrenade(FireMode[1]).mHoldClampMax);
}

function float SuggestAttackStyle()
{
    return 0.8;
}

function float SuggestDefenseStyle()
{
    return -0.8;
}

//========================================
//=== FIREMODES TO ROTATE 3RDP MESH ======
//========================================

simulated function bool StartFire(int Mode)
{
    	local Rotator endAt;
	
	if (Mode == 0)
    	{
    		endAt.Pitch = 0;
    		endAt.Yaw = 0;
    		endAt.Roll = 0;
    		ThirdPersonActor.SetRelativeRotation(endAt);	
    	}
    	super.startFire(mode);
   	return true;
}

simulated event StopFire(int Mode)
{
	local Rotator endAt;
	
	if (Mode == 0)
    	{
    		endAt.Pitch = 32768;
    		endAt.Yaw = 39152;
    		endAt.Roll = 0;
    		ThirdPersonActor.SetRelativeRotation(endAt);	
    	}	
	super.stopFire(mode);
}

//==========================================
//===FUNCTIONS TO PUT PLAYER IN 3RD PERSON==
//==========================================

simulated function BringUp(optional Weapon PrevWeapon)
{
     if (Pawn(Owner).PlayerReplicationinfo != none && !Pawn(Owner).PlayerReplicationinfo.bBot)
         ChangeView(true);

     Super.BringUp();
}

simulated function bool PutDown()
{
     if (Pawn(Owner).PlayerReplicationinfo != none && !Pawn(Owner).PlayerReplicationinfo.bBot)
         ChangeView(false);

    if ( Super.PutDown() )
    {
        GotoState('');
        return true;
    }
    return false;
}

simulated event ChangeView(bool Mode)
{
    PlayerController(Pawn(Owner).Controller).bbehindview = Mode;
}

//==========================================

defaultproperties
{
     blockrange=-0.640000
     FireModeClass(0)=grabin.swordFire
     FireModeClass(1)=grabin.swordAltFire
     PutDownAnim="PutDown"
     SelectForce="SwitchToAssaultRifle"
     AIRating=0.350000
     CurrentRating=0.350000
     bMeleeWeapon=True
     bCanThrow=False
     DisplayFOV=70.000000
     Priority=2
     CustomCrosshair=7
     CustomCrossHairTextureName="Crosshairs.HUD.Crosshair_Cross1"
     PickupClass=grabin.SwordPickup
     PlayerViewOffset=(X=-8.000000,Y=5.000000,Z=-6.000000)
     PlayerViewPivot=(Pitch=400)
     BobDamping=2.200000
     AttachmentClass=grabin.SwordAttachment
     IconMaterial=Texture'InterfaceContent.HUD.SkinA'
     IconCoords=(X1=200,Y1=100,X2=321,Y2=189)
     ItemName="Grabin Sword"
     LightType=LT_Pulse
     LightHue=30
     LightSaturation=150
     LightBrightness=150.000000
     LightRadius=4.000000
     LightPeriod=3
     Mesh=SkeletalMesh'NewWeapons2004.NewTranslauncher_1st'
     UV2Texture=Shader'XGameShaders.WeaponShaders.WeaponEnvShader'
}
